// 所有平台公用的全局变量和函数
// 定义一个变量来标识是否当前正在请求
let isRequesting = false;
// 定义分享按钮的文本
const shareButtonText = "磅礴分享";
// 定义分享进行中的文本
const sharingText = "分享中...";
// 定义主机地址，注意需要兼容不带www的情况
// const host = "https://www.eduprompt.cn"; 
const host = "https://www.eduprompt.cn";
// 定义分享API的路径
//const shareAPI = `/srv/ext/conversation`;
const shareAPI = "/api/Share/GetData";
const shareIconSvg = `<svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" class="w-3 h-3">
<path stroke-linecap="round" stroke-linejoin="round" d="M7.217 10.907a2.25 2.25 0 100 2.186m0-2.186c.18.324.283.696.283 1.093s-.103.77-.283 1.093m0-2.186l9.566-5.314m-9.566 7.5l9.566 5.314m0 0a2.25 2.25 0 103.935 2.186 2.25 2.25 0 00-3.935-2.186zm0-12.814a2.25 2.25 0 103.933-2.185 2.25 2.25 0 00-3.933 2.185z" />
</svg>`;
// 三个点图标
const ThreeDots = ` <svg viewBox="0 0 24 24">
<circle cx="4" cy="12" r="2" fill="currentColor"/>
<circle cx="12" cy="12" r="2" fill="currentColor"/>
<circle cx="20" cy="12" r="2" fill="currentColor"/>
<path fill="none" d="M0 0h24v24H0z"/>
</svg>`;
// 异步函数，用于将对话数据发布到指定的API
async function postConversationData(conversationData, source) {
    try {
        console.log(JSON.stringify(conversationData));
       const res = await fetch(`${host}${shareAPI}`, {
      body: JSON.stringify(conversationData),
      headers: { "Content-Type": "application/json" },
      method: "POST",
      credentials: 'include',
      mode: 'cors'  // 明确地指定这是一个CORS请求
    });
        // 如果请求成功，获取会话的ID并在新窗口中打开它
    if (res.ok) {
        const id = await res.text();
      window.open(host + "/User/Info", "_blank");
      isRequesting = false;
       // 如果请求失败，显示错误消息
    } else {
        const { message } = await res.text();
        alert(`分享失败：${message}`);
    }
  } catch (error) {
    isRequesting = false;
    console.log(`分享失败: ${error.message}`);
    alert(`分享失败: ${error.message}`);
  }
}
// 函数创建一个指定宽和高的Canvas和其2D上下文
function createCanvasAndCtx(width, height) {
  const canvas = document.createElement("canvas");
  const ctx = canvas.getContext("2d");
  canvas.width = width;
  canvas.height = height;

  // 将画布背景设置为透明
  ctx.clearRect(0, 0, width, height);
  ctx.fillStyle = "transparent";
  ctx.fillRect(0, 0, width, height);

  return { canvas, ctx };
}
// 函数将指定的图像渲染为DataURL，通常用于转换图像格式或应用图像效果
function renderImage(image, type = "image/png") {
  return new Promise((resolve) => {
    try {
      const img = new Image();
      img.crossOrigin = "Anonymous"; // 设置图片跨域属性
      img.src = image.src;

      img.onload = () => {
        const width = 30;
        const height = 30;
        const { canvas, ctx } = createCanvasAndCtx(width, height);

        // 在透明画布上绘制图像
        ctx.drawImage(img, 0, 0, width, height);

        const dataURL = canvas.toDataURL(type);
        resolve(dataURL);
      };
    } catch (error) {
      console.log("Error generating avatar image.", error);
      resolve(image.src);
    }
  });
}
// 监听从内容脚本或其他扩展部分发来的消息
chrome.runtime.onMessage.addListener(async function (
  request,
  sender,
  sendResponse
) {
  if (request.action === "shareSession" && shareSession) {
    try {
      await shareSession();
      sendResponse({ status: 1 });
    } catch (error) {
      sendResponse({ status: 0 });
    }
  }
});
