// 工具方法
console.log('utils.js');
// 获取当前页面的域名
function getDomain() {
    const url = window.location.href;
    const regex = /(https?:\/\/)([^/]*)(\/.*)?/;
    const matches = url.match(regex);
    return matches[2] || "";
}

const querySelector = selector => document.querySelector(selector)

/**
 * 等待元素加载函数
 * @param {String} selector 等待的元素的选择器
 * @param {*} callback 元素存在则立即调用 callback 函数
 * @param {*} max 最多执行次数
 */
function waitForElement(selector, callback, max = 10) {
    if(max <= 0) {
        console.error(`等待元素${selector}加载失败`);
        callback(null)
        return
    }

    const el = querySelector(selector);
    if (el) {
      callback(el);
    } else {
      setTimeout(() => waitForElement(selector, callback, max - 1), 500);
    }
}

// 设置元素的内联样式 
function setStyle(el, style = {}){
    for(let key in style){
        el.style[key] = style[key]
    }
}

// 是否为偶数
const isEven = num => num % 2 === 0