const classNames = {
  inputWrapper: ".oeNDrlEA", //提问框外容器
  cardListWrapper: ".ZuemGNIy", // 聊天对话外容器
  cardList: ".dialogueCardListContent", // 聊天对话
  prompt: ".nKBRQ4u9", // 提示
};

let inputWrapper = null;
let button = null;
let shareButtonWrapper = null;
const iconSvg = `<svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" width=".40rem" height=".20rem">
<path stroke-linecap="round" stroke-linejoin="round" d="M7.217 10.907a2.25 2.25 0 100 2.186m0-2.186c.18.324.283.696.283 1.093s-.103.77-.283 1.093m0-2.186l9.566-5.314m-9.566 7.5l9.566 5.314m0 0a2.25 2.25 0 103.935 2.186 2.25 2.25 0 00-3.935-2.186zm0-12.814a2.25 2.25 0 103.933-2.185 2.25 2.25 0 00-3.933 2.185z" />
</svg>`;

function createBtn() {
  const button = document.createElement("button");
  setStyle(button, {
    border: "1px solid #4955f5",
    cursor: "pointer",
    "align-items": "center",
    "border-radius": "5px",
    display: "flex",
    "justify-content": "center",
    "align-items": "center",
    color: "#4955f5",
    padding: "8px",
    "background-color": "#fff",
  });

  button.innerHTML = `${iconSvg}${shareButtonText}`;

  return button;
}

function createBtnWrapper() {
  const btnWrapper = document.createElement("div");
  const button = createBtn();

  setStyle(btnWrapper, {
    width: "100%",
    height: "46px",
    padding: "4px",
    display: "flex",
    "justify-content": "center",
    "align-items": "center",
  });

  btnWrapper.appendChild(button);
  return {
    button,
    btnWrapper,
  };
}

function appendShareButton() {
  const firstChild = inputWrapper.firstChild;
  if (firstChild) {
    inputWrapper.insertBefore(shareButtonWrapper, firstChild);
  } else {
    inputWrapper.appendChild(shareButtonWrapper);
  }
}

function removeShareButton() {
  inputWrapper.removeChild(shareButtonWrapper);
}

function createObserver() {
  const observer = new MutationObserver(function (mutations_list) {
    mutations_list.forEach(function (mutation) {
      if (mutation.addedNodes.length > 0) {
        for (const el of mutation.addedNodes) {
          if (el.matches(classNames.cardList)) {
            appendShareButton();
            continue;
          } else if (el.matches(classNames.prompt)) {
            removeShareButton();
            continue;
          }
        }
      }
    });
  });

  observer.observe(querySelector(classNames.cardListWrapper), {
    childList: true,
  });
  return observer;
}

function setBtnStatus(button, status = "init") {
  if (status === "init") {
    button.innerHTML = `${iconSvg}${shareButtonText}`;
    button.style.cursor = "pointer";
  } else if (status === "sharing") {
    button.textContent = sharingText;
    button.style.cursor = "initial";
  }
}

function getAvatarImage() {
  const image = document.querySelectorAll("img")[1];

  // return renderImage(image)
  return new Promise((resolve) => {
    resolve(image.src);
  });
}

function getDialogue() {
  const result = [];

  try {
    const chatEls = document.querySelectorAll(".B0XmwKds");

    // 文心一言的对话是反过来的
    // 暂时不做判断，默认第一个为人类
    for (let i = chatEls.length - 1; i >= 0; i--) {
      const el = chatEls[i];
      if (isEven(i)) {
        result.push({
          from: "yiyan",
          value: el.outerHTML,
        });
      } else {
        result.push({
          from: "human",
          value: el.innerText,
        });
      }
    }
  } catch (e) {
    console.log(e);
  }

  return result;
}

async function shareSession() {
  try {
    if (isRequesting) return;

    isRequesting = true;

    const avatarUrl = await getAvatarImage();
    console.log(avatarUrl);
    const items = getDialogue();
    const conversationData = {
      avatarUrl,
      model: "",
      items,
      source: "yiyan",
    };

    console.error(conversationData);

    setBtnStatus(button, "sharing");

    await postConversationData(conversationData, "gpt");
    setBtnStatus(button, "init");
  } catch (error) {
    setBtnStatus(button, "init");
    isRequesting = false;
  }
}

function init() {
  console.log("yiyan.js");
  const doms = createBtnWrapper();
  shareButtonWrapper = doms.btnWrapper;
  button = doms.button;

  const observer = createObserver();

  button.addEventListener("click", shareSession);
}

window.onload = async () => {
  waitForElement(classNames.inputWrapper, (el) => {
    inputWrapper = el;
    init();
  });
};
